收集 Atlassian 组织审核日志
解析器版本:1.0
本文档介绍了如何使用 Google Cloud Storage V2 将 Atlassian 组织审核日志注入到 Google Security Operations。
Atlassian 组织审核日志可在 admin.atlassian.com 中集中记录 Atlassian 组织中的管理活动。它会捕获用户配置、群组成员资格变更、身份验证政策更新和 API 密钥管理等事件,使安全团队能够监控和调查组织管理员所做的更改。
准备工作
请确保您满足以下前提条件:
- Google SecOps 实例
- 已启用 Cloud Storage API 的 GCP 项目
- 创建和管理 GCS 存储分区的权限
- 管理 GCS 存储分区的 IAM 政策的权限
- 创建 Cloud Run 服务、Pub/Sub 主题和 Cloud Scheduler 作业的权限
- 对 admin.atlassian.com 中的 Atlassian 组织管理功能拥有特权访问权限
- 已订阅 Atlassian Guard(标准版或高级版)或至少已订阅一项企业版方案(组织审核日志必需)的 Atlassian 组织
创建 Google Cloud Storage 存储桶
- 前往 Google Cloud 控制台。
- 选择您的项目或创建新项目。
- 在导航菜单中,依次前往 Cloud Storage > 存储分区。
- 点击创建存储分区。
提供以下配置详细信息:
设置 值 为存储桶命名 输入一个全局唯一的名称(例如 atlassian-audit-logs)位置类型 根据您的需求进行选择(区域级、双区域、多区域) 位置 选择营业地点(例如 us-central1)存储类别 标准(建议用于经常访问的日志) 访问权限控制 均匀(推荐) 保护工具 可选:启用对象版本控制或保留政策 点击创建。
收集 Atlassian API 凭据
创建 API 密钥
- 登录 admin.atlassian.com。
- 如果您有多个组织,请选择您的组织。
- 依次前往设置 > API 密钥。
- 点击创建 API 密钥。
- 为密钥输入一个描述性名称(例如
SecOps-Audit-Collector)。 设置失效日期。
点击创建。
请妥善复制并保存 API 密钥值。关闭此对话框后,您将无法恢复 API 密钥值。
记下浏览器地址栏中网址中的组织 ID(
https://admin.atlassian.com/o/{orgId}/...中的 UUID)。点击完成。
验证权限
如需通过 API 访问组织审核日志,您必须是组织管理员:
- 登录 admin.atlassian.com。
- 依次前往设置 > API 密钥。
- 如果您可以查看 API 密钥页面并创建密钥,则表示您拥有所需的组织管理员权限。
- 如果您看不到此选项,请与您的 Atlassian 组织管理员联系,以获取组织管理员访问权限。
测试 API 访问权限
在继续进行集成之前,请先测试您的凭据:
# Replace with your actual credentials API_KEY="<your-atlassian-api-key>" ORG_ID="<your-organization-id>" # Test API access using the events-stream endpoint curl -v \ --header "Authorization: Bearer ${API_KEY}" \ --header "Accept: application/json" \ "https://api.atlassian.com/admin/v1/orgs/${ORG_ID}/events-stream?limit=1"
如果响应成功,则会返回 HTTP 200,并附带一个包含事件对象 data 数组的 JSON 正文。
为 Cloud Run 函数创建服务账号
Cloud Run 函数需要一个服务账号,该账号具有写入 GCS 存储桶的权限,并且可以由 Pub/Sub 调用。
创建服务账号
- 在 GCP 控制台中,依次前往 IAM 和管理 > 服务账号。
- 点击创建服务账号。
- 提供以下配置详细信息:
- 服务账号名称:输入
atlassian-audit-collector-sa - 服务账号说明:输入
Service account for Cloud Run function to collect Atlassian Organization Audit logs
- 服务账号名称:输入
- 点击创建并继续。
- 在向此服务账号授予对项目的访问权限部分中,添加以下角色:
- 点击选择角色。
- 搜索并选择 Storage Object Admin。
- 点击 + 添加其他角色。
- 搜索并选择 Cloud Run Invoker。
- 点击 + 添加其他角色。
- 搜索并选择 Cloud Functions Invoker。
- 点击继续。
- 点击完成。
必须拥有这些角色,才能:
- Storage Object Admin:将日志写入 GCS 存储桶并管理状态文件
- Cloud Run Invoker:允许 Pub/Sub 调用函数
- Cloud Functions Invoker:允许调用函数
授予对 GCS 存储桶的 IAM 权限
向服务账号授予对 GCS 存储桶的写入权限:
- 前往 Cloud Storage > 存储分区。
- 点击您的存储桶名称(例如
atlassian-audit-logs)。 - 前往权限标签页。
- 点击授予访问权限。
- 提供以下配置详细信息:
- 添加主账号:输入服务账号电子邮件地址(例如
atlassian-audit-collector-sa@PROJECT_ID.iam.gserviceaccount.com) - 分配角色:选择 Storage Object Admin
- 添加主账号:输入服务账号电子邮件地址(例如
- 点击保存。
创建 Pub/Sub 主题
创建一个 Pub/Sub 主题,Cloud Scheduler 将向该主题发布消息,而 Cloud Run 函数将订阅该主题。
- 在 GCP 控制台中,前往 Pub/Sub > 主题。
- 点击创建主题。
- 提供以下配置详细信息:
- 主题 ID:输入
atlassian-audit-logs-trigger - 将其他设置保留为默认值
- 主题 ID:输入
- 点击创建。
创建 Cloud Run 函数以收集日志
Cloud Run 函数将由来自 Cloud Scheduler 的 Pub/Sub 消息触发,以轮询 Atlassian Organizations REST API 中的审核日志事件,并将其写入 GCS。
- 在 GCP 控制台中,前往 Cloud Run。
- 点击创建服务。
- 选择函数(使用内嵌编辑器创建函数)。
在配置部分中,提供以下配置详细信息:
设置 值 Service 名称 atlassian-audit-collector区域 选择与您的 GCS 存储桶匹配的区域(例如 us-central1)运行时 选择 Python 3.12 或更高版本 在触发器(可选)部分中:
- 点击 + 添加触发器。
- 选择 Cloud Pub/Sub。
- 在选择 Cloud Pub/Sub 主题中,选择 Pub/Sub 主题 (
atlassian-audit-logs-trigger)。 - 点击保存。
在身份验证部分中:
- 选择需要进行身份验证。
- 检查 Identity and Access Management (IAM)。
向下滚动并展开容器、网络、安全性。
前往安全性标签页:
- 服务账号:选择服务账号 (
atlassian-audit-collector-sa)
- 服务账号:选择服务账号 (
前往容器标签页:
- 点击变量和密钥。
- 为每个环境变量点击+ 添加变量:
变量名称 示例值 说明 GCS_BUCKETatlassian-audit-logsGCS 存储桶名称 GCS_PREFIXatlassian-audit日志文件的前缀 STATE_KEYatlassian-audit/state.json状态文件路径 ATL_TOKENyour-atlassian-api-keyAtlassian API 密钥 ATL_ORG_IDyour-organization-idAtlassian 组织 ID MAX_RECORDS1000每次运行的记录数上限 PAGE_SIZE200每页记录数(最多 500 条) LOOKBACK_HOURS24初始回溯期 在变量和 Secret 部分中,向下滚动到请求:
- 请求超时:输入
600秒(10 分钟)
- 请求超时:输入
前往设置标签页:
- 在资源部分中:
- 内存:选择 512 MiB 或更高值
- CPU:选择 1
- 在资源部分中:
在修订版本伸缩部分中:
- 实例数下限:输入
0 - 实例数上限:输入
100(或根据预期负载进行调整)
- 实例数下限:输入
点击创建。
等待服务创建完成(1-2 分钟)。
创建服务后,系统会自动打开内嵌代码编辑器。
添加函数代码
- 在入口点字段中输入 main。
在内嵌代码编辑器中,创建两个文件:
- main.py:
import functions_framework from google.cloud import storage import json import os import urllib3 from datetime import datetime, timezone, timedelta from urllib.parse import urlparse, parse_qs import time # Initialize HTTP client with timeouts http = urllib3.PoolManager( timeout=urllib3.Timeout(connect=5.0, read=30.0), retries=False, ) # Initialize Storage client storage_client = storage.Client() # Environment variables GCS_BUCKET = os.environ.get('GCS_BUCKET') GCS_PREFIX = os.environ.get('GCS_PREFIX', 'atlassian-audit') STATE_KEY = os.environ.get('STATE_KEY', 'atlassian-audit/state.json') ATL_TOKEN = os.environ.get('ATL_TOKEN') ATL_ORG_ID = os.environ.get('ATL_ORG_ID') MAX_RECORDS = int(os.environ.get('MAX_RECORDS', '1000')) PAGE_SIZE = int(os.environ.get('PAGE_SIZE', '200')) LOOKBACK_HOURS = int(os.environ.get('LOOKBACK_HOURS', '24')) def parse_datetime(value): """Parse ISO datetime string to datetime object.""" if value.endswith("Z"): value = value[:-1] + "+00:00" return datetime.fromisoformat(value) @functions_framework.cloud_event def main(cloud_event): """ Cloud Run function triggered by Pub/Sub to fetch Atlassian Organization Audit logs via the events-stream endpoint and write to GCS. Args: cloud_event: CloudEvent object containing Pub/Sub message """ if not all([GCS_BUCKET, ATL_TOKEN, ATL_ORG_ID]): print('Error: Missing required environment variables') return try: # Get GCS bucket bucket = storage_client.bucket(GCS_BUCKET) # Load state state = load_state(bucket, STATE_KEY) # Determine time window now = datetime.now(timezone.utc) last_time = None if isinstance(state, dict) and state.get("last_event_time"): try: last_time = parse_datetime(state["last_event_time"]) # Overlap by 2 minutes to catch any delayed events last_time = last_time - timedelta(minutes=2) except Exception as e: print(f"Warning: Could not parse last_event_time: {e}") if last_time is None: last_time = now - timedelta(hours=LOOKBACK_HOURS) print(f"Fetching logs from {last_time.isoformat()} to {now.isoformat()}") # Fetch logs using the events-stream polling endpoint records, newest_event_time = fetch_logs( start_time=last_time, end_time=now, page_size=PAGE_SIZE, max_records=MAX_RECORDS, ) if not records: print("No new log records found.") save_state(bucket, STATE_KEY, now.isoformat()) return # Write to GCS as NDJSON timestamp_str = now.strftime('%Y%m%d_%H%M%S') object_key = f"{GCS_PREFIX}/logs_{timestamp_str}.ndjson" blob = bucket.blob(object_key) ndjson = '\n'.join([json.dumps(record, ensure_ascii=False) for record in records]) + '\n' blob.upload_from_string(ndjson, content_type='application/x-ndjson') print(f"Wrote {len(records)} records to gs://{GCS_BUCKET}/{object_key}") # Update state with newest event time if newest_event_time: save_state(bucket, STATE_KEY, newest_event_time) else: save_state(bucket, STATE_KEY, now.isoformat()) print(f"Successfully processed {len(records)} records") except Exception as e: print(f'Error processing logs: {str(e)}') raise def load_state(bucket, key): """Load state from GCS.""" try: blob = bucket.blob(key) if blob.exists(): state_data = blob.download_as_text() return json.loads(state_data) except Exception as e: print(f"Warning: Could not load state: {e}") return {} def save_state(bucket, key, last_event_time_iso): """Save the last event timestamp to GCS state file.""" try: state = {'last_event_time': last_event_time_iso} blob = bucket.blob(key) blob.upload_from_string( json.dumps(state, indent=2), content_type='application/json' ) print(f"Saved state: last_event_time={last_event_time_iso}") except Exception as e: print(f"Warning: Could not save state: {e}") def fetch_logs(start_time, end_time, page_size, max_records): """ Fetch audit logs from Atlassian Organization events-stream API with cursor-based pagination. The events-stream endpoint is designed for polling use cases and supports higher throughput than the /events query endpoint. API reference: https://developer.atlassian.com/cloud/admin/organization/rest/api-group-events/ Args: start_time: Start time for log query end_time: End time for log query page_size: Number of records per page (max 500) max_records: Maximum total records to fetch Returns: Tuple of (records list, newest_event_time ISO string) """ endpoint = f"https://api.atlassian.com/admin/v1/orgs/{ATL_ORG_ID}/events-stream" headers = { 'Authorization': f'Bearer {ATL_TOKEN}', 'Accept': 'application/json', 'User-Agent': 'GoogleSecOps-AtlassianAuditCollector/1.0' } records = [] newest_time = None page_num = 0 backoff = 1.0 cursor = None while True: page_num += 1 if len(records) >= max_records: print(f"Reached max_records limit ({max_records})") break # Build request URL with query parameters params = [ f"from={start_time.strftime('%Y-%m-%dT%H:%M:%S.000Z')}", f"to={end_time.strftime('%Y-%m-%dT%H:%M:%S.000Z')}", f"limit={min(page_size, max_records - len(records))}", ] if cursor: params.append(f"cursor={cursor}") url = f"{endpoint}?{'&'.join(params)}" try: response = http.request('GET', url, headers=headers) # Handle rate limiting with exponential backoff if response.status == 429: retry_after = int(response.headers.get('Retry-After', str(int(backoff)))) print(f"Rate limited (429). Retrying after {retry_after}s...") time.sleep(retry_after) backoff = min(backoff * 2, 30.0) continue backoff = 1.0 if response.status != 200: print(f"HTTP Error: {response.status}") response_text = response.data.decode('utf-8') print(f"Response body: {response_text}") return [], None data = json.loads(response.data.decode('utf-8')) page_results = data.get('data', []) if not page_results: print(f"No more results (empty page)") break print(f"Page {page_num}: Retrieved {len(page_results)} events") records.extend(page_results) # Track newest event time from attributes for event in page_results: try: attrs = event.get('attributes', {}) event_time = attrs.get('time') if event_time: if newest_time is None or parse_datetime(event_time) > parse_datetime(newest_time): newest_time = event_time except Exception as e: print(f"Warning: Could not parse event time: {e}") # Check for next page using links.next or meta.next cursor next_link = data.get('links', {}).get('next') if not next_link: next_cursor = data.get('meta', {}).get('next') if not next_cursor: print("No more pages (no next cursor)") break cursor = next_cursor else: # Extract cursor from next link URL parsed = urlparse(next_link) query_params = parse_qs(parsed.query) cursor = query_params.get('cursor', [None])[0] if not cursor: break except Exception as e: print(f"Error fetching logs: {e}") return [], None print(f"Retrieved {len(records)} total records from {page_num} pages") return records, newest_time- requirements.txt:
functions-framework==3.* google-cloud-storage==2.* urllib3>=2.0.0点击部署以保存并部署该函数。
等待部署完成(2-3 分钟)。
创建 Cloud Scheduler 作业
Cloud Scheduler 会定期向 Pub/Sub 主题发布消息,从而触发 Cloud Run 函数。
- 在 GCP Console 中,前往 Cloud Scheduler。
- 点击创建作业。
提供以下配置详细信息:
设置 值 名称 atlassian-audit-collector-hourly区域 选择与 Cloud Run 函数相同的区域 频率 0 * * * *(每小时一次,整点时)时区 选择时区(建议选择 UTC) 目标类型 Pub/Sub 主题 选择 Pub/Sub 主题 ( atlassian-audit-logs-trigger)消息正文 {}(空 JSON 对象)点击创建。
时间表频率选项
根据日志量和延迟时间要求选择频次:
| 频率 | Cron 表达式 | 使用场景 |
|---|---|---|
| 每隔 5 分钟 | */5 * * * * |
大批量、低延迟 |
| 每隔 15 分钟 | */15 * * * * |
搜索量中等 |
| 每小时 | 0 * * * * |
标准(推荐) |
| 每 6 小时 | 0 */6 * * * |
低成交量、批处理 |
| 每天 | 0 0 * * * |
历史数据收集 |
测试集成
- 在 Cloud Scheduler 控制台中,找到您的作业。
- 点击强制运行以手动触发作业。
- 等待几秒钟。
- 前往 Cloud Run > 服务。
- 点击函数名称 (
atlassian-audit-collector)。 - 点击日志标签页。
验证函数是否已成功执行。查找:
Fetching logs from YYYY-MM-DDTHH:MM:SS+00:00 to YYYY-MM-DDTHH:MM:SS+00:00 Page 1: Retrieved X events Wrote X records to gs://atlassian-audit-logs/atlassian-audit/logs_YYYYMMDD_HHMMSS.ndjson Successfully processed X records前往 Cloud Storage > 存储分区。
点击您的存储桶名称 (
atlassian-audit-logs)。前往前缀文件夹 (
atlassian-audit/)。验证是否已创建具有当前时间戳的新
.ndjson文件。
如果您在日志中看到错误,请执行以下操作:
- HTTP 401:检查环境变量中的 API 密钥
- HTTP 403:验证组织管理员权限和 Atlassian Guard 订阅
- HTTP 429:速率限制 - 函数将自动重试并进行退避
- 缺少环境变量:检查是否已设置所有必需的变量
检索 Google SecOps 服务账号
Google SecOps 使用唯一的服务账号从您的 GCS 存储桶中读取数据。您必须授予此服务账号对您的存储桶的访问权限。
获取服务账号电子邮件地址
- 依次前往 SIEM 设置 > Feed。
- 点击添加新 Feed。
- 点击配置单个 Feed。
- 在 Feed 名称字段中,输入 Feed 的名称(例如
Atlassian Audit Logs)。 - 选择 Google Cloud Storage V2 作为来源类型。
- 选择 ATLASSIAN_AUDIT 作为日志类型。
- 点击获取服务账号。
系统会显示一个唯一的服务账号电子邮件地址,例如:
chronicle-12345678@chronicle-gcp-prod.iam.gserviceaccount.com复制此电子邮件地址,以便在下一步中使用。
点击下一步。
为以下输入参数指定值:
存储桶网址:输入带有前缀路径的 GCS 存储桶 URI:
gs://atlassian-audit-logs/atlassian-audit/
来源删除选项:根据您的偏好选择删除选项:
- 永不:转移后永不删除任何文件(建议用于测试)。
- 删除已转移的文件:在成功转移后删除文件。
删除已转移的文件和空目录:成功转移后删除文件和空目录。
文件存在时间上限:包含在过去指定天数内修改的文件(默认值为 180 天)
资产命名空间:资产命名空间
注入标签:要应用于此 Feed 中事件的标签
点击下一步。
在最终确定界面中查看新的 Feed 配置,然后点击提交。
向 Google SecOps 服务账号授予 IAM 权限
Google SecOps 服务账号需要您的 GCS 存储桶的 Storage Object Viewer 角色。
- 前往 Cloud Storage > 存储分区。
- 点击您的存储桶名称 (
atlassian-audit-logs)。 - 前往权限标签页。
- 点击授予访问权限。
- 提供以下配置详细信息:
- 添加主账号:粘贴 Google SecOps 服务账号电子邮件地址
- 分配角色:选择 Storage Object Viewer
点击保存。
UDM 映射表
| 日志字段 | UDM 映射 | 逻辑 |
|---|---|---|
attributes.time |
metadata.event_timestamp |
从原始日志的 attributes.time 字段中解析。 |
attributes.action |
metadata.product_event_type |
该值取自 attributes.action 字段。 |
attributes.actor.id |
principal.user.product_object_id |
该值取自 attributes.actor.id 字段。 |
attributes.actor.name |
principal.user.user_display_name |
该值取自 attributes.actor.name 字段。 |
attributes.actor.email |
principal.user.email_addresses |
该值取自 attributes.actor.email 字段。 |
attributes.location.ip |
principal.ip |
该值取自 attributes.location.ip 字段。 |
attributes.location.geo |
principal.location.country_or_region |
该值取自 attributes.location.geo 字段。 |
attributes.location.countryName |
principal.location.name |
该值取自 attributes.location.countryName 字段。 |
attributes.context[].id |
target.resource.product_object_id |
该值取自上下文 id 字段。 |
attributes.context[].type |
target.resource.resource_subtype |
该值取自上下文 type 字段。 |
attributes.container[].id |
target.resource.attribute.labels |
容器 id 将作为标签添加。 |
attributes.container[].type |
target.resource.attribute.labels |
容器 type 将作为标签添加。 |
message.content |
security_result.summary |
该值取自 message.content 字段。 |
metadata.event_type |
根据可用字段进行映射:对于资源修改,为 USER_RESOURCE_UPDATE_CONTENT;否则为 GENERIC_EVENT。 |
|
metadata.product_name |
设置为 Atlassian Admin。 |
|
metadata.vendor_name |
设置为 Atlassian。 |